import splunk.admin as admin
import splunk.entity as en
import os

class ConfigApp(admin.MConfigHandler):
    def setup(self):
        if self.requestedAction == admin.ACTION_EDIT:
            for arg in ['mfakey','mfaenabled']:
                self.supportedArgs.addOptArg(arg)

    def handleList(self, confInfo):
        confDict = self.readConf("mfasetup")
        if None != confDict:
            for stanza, settings in confDict.items():
                for key, val in settings.items():
                    if key in ['mfakey'] and val in [None, '']:
                        val=''
                    confInfo[stanza].append(key,val)
    
    def handleEdit(self, confInfo):
        name = self.callerArgs.id
        args = self.callerArgs
        script = 'script://' + os.path.join('.','bin','mfapoll.py')
        scriptSettings = { 
          "interval": 300,
          "sourcetype": "_json",
          "disabled": "false"
        }
        
        if self.callerArgs.data['mfakey'][0] in [None, '']:
            self.callerArgs.data['mfakey'][0] = ''
            
        self.writeConf('mfasetup', 'mfasetup', self.callerArgs.data)
        self.writeConf('inputs', script, scriptSettings)
        
admin.init(ConfigApp, admin.CONTEXT_NONE)

