import splunk.admin as admin
import splunk.entity as en
import os

class ConfigApp(admin.MConfigHandler):
    def setup(self):
        if self.requestedAction == admin.ACTION_EDIT:
            for arg in ['webkey','webenabled']:
                self.supportedArgs.addOptArg(arg)

    def handleList(self, confInfo):
        confDict = self.readConf("websetup")
        if None != confDict:
            for stanza, settings in confDict.items():
                for key, val in settings.items():
                    if key in ['webkey'] and val in [None, '']:
                        val=''
                    confInfo[stanza].append(key,val)
    
    def handleEdit(self, confInfo):
        name = self.callerArgs.id
        args = self.callerArgs
        webScript = 'script://' + os.path.join('.','bin','webpoll.py')
        appScript = 'script://' + os.path.join('.','bin','apppoll.py')
        scriptSettings = {
          "interval": 300,
          "sourcetype": "_json",
          "disabled": "false"
        }
        
        if self.callerArgs.data['webkey'][0] in [None, '']:
            self.callerArgs.data['webkey'][0] = ''
            
        self.writeConf('websetup', 'websetup', self.callerArgs.data)
        self.writeConf('inputs', webScript, scriptSettings)
        self.writeConf('inputs', appScript, scriptSettings)
        
admin.init(ConfigApp, admin.CONTEXT_NONE)

